    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.scheme;
    022
    023import cascading.tap.Tap;
    024import cascading.tuple.TupleEntry;
    025
    026/**
    027 * SourceCall provides access to the current {@link Scheme#source(cascading.flow.FlowProcess, SourceCall)} invocation
    028 * arguments.
    029 * <p/>
    030 * Use the Context to store thread local values.
    031 *
    032 * @param <Context>
    033 * @param <Input>
    034 */
    035public interface SourceCall<Context, Input>
    036  {
    037  /**
    038   * Method getContext returns the context of this SourceCall object.
    039   *
    040   * @return the context (type C) of this SourceCall object.
    041   */
    042  Context getContext();
    043
    044  /**
    045   * Method setContext sets the context of this SourceCall object.
    046   *
    047   * @param context the context of this SourceCall object.
    048   */
    049  void setContext( Context context );
    050
    051  /**
    052   * Method getIncomingEntry returns a pre-prepared {@link TupleEntry} to be populated
    053   * with the input values from {@link #getInput()}.
    054   * <p/>
    055   * That is, using the getInput() method, retrieve the current incoming values and
    056   * place them into the getIncomingEntry() via {@link TupleEntry#setTuple(cascading.tuple.Tuple)}
    057   * or by modifying the tuple returned from {@link cascading.tuple.TupleEntry#getTuple()}.
    058   * <p/>
    059   * The returned Tuple entry is guaranteed to be the size of the declared incoming source fields.
    060   * <p/>
    061   * The returned TupleEntry from this method is modifiable and is intended to be re-used. This is an exception to
    062   * the general rule that passed TupleEntry instances must not be modified.
    063   *
    064   * @return TupleEntry
    065   */
    066  TupleEntry getIncomingEntry();
    067
    068  /**
    069   * Method getInput returns the input mechanism for the underlying platform used to retrieve new values (records,
    070   * lines, etc).
    071   * <p/>
    072   * Do not cache the returned value as it may change.
    073   *
    074   * @return the platform dependent input handler
    075   */
    076  Input getInput();
    077
    078  /**
    079   * Method getTap returns the parent {@link Tap} instance that encapsulates the current {@link Scheme} instance.
    080   *
    081   * @return the parent Tap
    082   */
    083  Tap getTap();
    084  }